.TH AGG 1 2011-06-26 agg "the news aggregator"

.SH NAME
.B agg
\- the news aggregator

.SH SYNOPSIS
cat feed.rss | 
.B agg

.SH DESCRIPTION
.B agg
reads a news feed (currently RSS 2.0 only) from stdin and
creates or updates its filesystem representation.

.SH FILE SYSTEM
The following hierarchy in the current working
directory is created/maintained.

.nf
	$FEED_NAME
	|-- $ITEM_1
	|   |-- desc
	|   |-- link
	|   `-- title
	|-- ...
	`-- $ITEM_N
.fi

Where link, title and desc are missing if not present in
news feed, but at least one of title or desc will exist
(i.e. the news feed conforms to the RSS 2.0).

.SH USAGE
The mtime of files and directories is used to represent
dates of publication.

If the feed directory does not exist,
.B agg
will create it and store all items in the feed there.
The mtimes of the item directories will be set to the
corresponding date of publication, the mtime of the feed
directory will be set to the date of publication of the
most recent item.

If the feed directory already exists (e.g. on subsequent
runs),
.B agg
checks the mtime of the feed directory and only fetches
items with a newer date of publication, again setting the
mtimes for the items fetched in this run. The mtime of the
feed directory will be set to the date of publication of
the most recent item that was fetched in this run.

If an item does not have a publication date, it is set to
the UNIX timestamp 0.

By manually changing the mtime of the feed directory, you
can make agg either skip unfetched items or refetch old
ones.

To avoid unintentionally changing the mtime and thus
skipping items, you can use a tiny wrapper called
.B nomtime.

.SH BUGS

.IP * 2
Supports only RSS.
.IP * 2
Uses fixed size buffers to simplify code. May lead
cut-off news texts or links. The chances for this to
happen are low and without much consequences.
.IP * 2
Assumes items only change if their publication date
changes. Again, for simplicity.
.IP * 2
Creation of a "sub-feed" directory if the channel contained
an element that had a title tag but is not an item.
.IP * 2
Supports only dates that have their time zone formatted as
+xxxx, not as their abbreviation.
.IP * 2
Item titles may conflict.
.IP * 2
Standard mtime for items without pubDate should be now().
.IP * 2
Only tested on GNU/Linux.

.SH REPOSITORY

.nf
git://repo.or.cz/agg.git
http://www.repo.or.cz/w/agg.git
.fi

.SH HOMEPAGE

http://programmers.at/work/on/agg

.SH LICENSE

Copyright (C) 2011 Andreas Waidler <arandes@programmers.at>

Permission to use, copy, modify, and/or distribute this
software for any purpose with or without fee is hereby
granted, provided that the above copyright notice and this
permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS
ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE
USE OR PERFORMANCE OF THIS SOFTWARE.
